<?php
if (isset($_REQUEST['skrillModulId'])) {
    include_once PFAD_ROOT . PFAD_INCLUDES_MODULES . 'PaymentMethod.class.php';
    include_once(dirname(__FILE__).'/../paymentmethod/classes/payment/core.php');
    include_once(dirname(__FILE__).'/../paymentmethod/classes/payment/Skrill.php');

    $paymentMethod = PaymentMethod::create($_REQUEST['skrillModulId']);

    if ($paymentMethod) {
        $hash = isset($_REQUEST['ph']) ? $_REQUEST['ph'] : $_REQUEST['sh'];
        $cZahlungsID = $hash[0] == '_' ? substr($hash, 1) : $hash;
        if (isset($_REQUEST['ph'])) {
            $sessionSave = Shop::DB()->select(
                'tzahlungsid',
                'cId',
                $cZahlungsID,
                null,
                null,
                null,
                null,
                false,
                'kBestellung, dDatum'
            );
            $antiFraudDate = $sessionSave->dDatum;
        } else {
            $sessionSave = Shop::DB()->select(
                'tzahlungsession',
                'cZahlungsID',
                $cZahlungsID,
                null,
                null,
                null,
                null,
                false,
                'cSID, kBestellung, dZeit'
            );
            $antiFraudDate = $sessionSave->dZeit;
        }

        if (isset($_REQUEST['is_status_url'])) {
            Jtllog::writeLog('Skrill status url response : ' . print_r($_REQUEST, true), JTLLOG_LEVEL_NOTICE);
            $paymentResult = array();
            foreach ($_REQUEST as $parameter => $value) {
                $parameter = strtolower($parameter);
                $paymentResult[$parameter] = $value;
            }

            $skrillSettings = $paymentMethod->getSkrillSettings();
            $isFraud = SkrillPayment::isFraud(
                $paymentResult['amount'],
                $hash,
                $antiFraudDate,
                $paymentResult['secure_payment']
            );

            if ($isFraud) {
                $paymentResult['status'] = $paymentMethod::FRAUD_STATUS;
                Jtllog::writeLog('Skrill suspected fraud : '.$paymentResult['mb_transaction_id'], JTLLOG_LEVEL_ERROR);
            } else {
                $isCredentialValid = SkrillPayment::isCredentialValid($skrillSettings, $paymentResult);

                if (!$isCredentialValid) {
                    $paymentResult['status'] = $paymentMethod::NOT_VERIFIED_STATUS;
                    Jtllog::writeLog('Skrill not verified : '.$paymentResult['mb_transaction_id'], JTLLOG_LEVEL_ERROR);
                }
            }

            $isSkrillOrderExist = $paymentMethod->isSkrillOrderExist($paymentResult['transaction_id']);
            if ($isSkrillOrderExist) {
                $paymentMethod->updateSkrillOrder($paymentResult);
            } else {
                $paymentMethod->addSkrillOrder($paymentResult);
            }

            if ($sessionSave && $sessionSave->kBestellung) {
                $order = new stdClass();
                $incomingPayment = new stdClass();
                $order->order_id  = intval($sessionSave->kBestellung);
                Shop::DB()->update(
                    'xplugin_jtl_skrill_orders',
                    'mb_transaction_id',
                    $paymentResult['mb_transaction_id'],
                    $order
                );
                $paymentMethod->updateOrderStatus($sessionSave->kBestellung, $paymentResult['status']);

                Jtllog::writeLog('Skrill status url update order : '.$sessionSave->kBestellung.'; status : '.
                    $paymentResult['status'], JTLLOG_LEVEL_NOTICE);

                $order = new Bestellung($sessionSave->kBestellung);
                $paymentMethod->sendConfirmationMail($order);

                $incomingPayment->fBetrag = $order->fGesamtsumme;
                $incomingPayment->cISO = $order->Waehrung->cISO;
                $incomingPayment->cZahler = $paymentMethod->getPaymentType();
                $incomingPayment->cHinweis = $args['mb_transaction_id'];
                $paymentMethod->addIncomingPayment($order, $incomingPayment);
                exit;
            } else {
                $_REQUEST['mb_transaction_id'] = $paymentResult['mb_transaction_id'];
            }
        } elseif (isset($_REQUEST['transaction_id']) && isset($_REQUEST['msid'])) {
            Jtllog::writeLog('Skrill return url', JTLLOG_LEVEL_NOTICE);

            $isSkrillOrderExist = $paymentMethod->isSkrillOrderExist($_REQUEST['transaction_id']);

            if (!$isSkrillOrderExist) {
                $paymentMethod->addSkrillOrder($paymentResult);
            }
            
            if ($sessionSave && $sessionSave->kBestellung) {
                $order = new Bestellung($sessionSave->kBestellung);

                if ($order->cStatus == BESTELLUNG_STATUS_OFFEN) {
                    Jtllog::writeLog('status', BESTELLUNG_STATUS_OFFEN);
                    Jtllog::writeLog('Skrill return url redirect pending', JTLLOG_LEVEL_NOTICE);
                } elseif ($order->cStatus == BESTELLUNG_STATUS_BEZAHLT) {
                    Jtllog::writeLog('Skrill return url redirect success', JTLLOG_LEVEL_NOTICE);
                    if (isset($_REQUEST['sh'])) {
                        $cZahlungsID = '_'.$cZahlungsID;
                    }
                    $header = 'Location: ' . gibShopURL() . '/bestellabschluss.php?i='.$cZahlungsID;
                    header($header);
                    exit();
                } elseif ($order->cStatus == BESTELLUNG_STATUS_STORNO) {
                    $paymentResult = Shop::DB()->select(
                        'xplugin_jtl_skrill_orders',
                        'order_id',
                        $sessionSave->kBestellung
                    );
                    
                    $paymentStatus = unserialize($paymentResult->payment_status);
                    $errorIdentifier = SkrillPayment::getSkrillErrorMapping($paymentStatus['status']);
                    Jtllog::writeLog('Skrill return url redirect error', JTLLOG_LEVEL_ERROR);
                    $paymentMethod->redirectError($errorIdentifier);
                }
            } else {
                Jtllog::writeLog('Skrill return url session not found : '.$cZahlungsID, JTLLOG_LEVEL_ERROR);
            }
        }
    }
}
